package geoPos;
import java.util.Date;
import javax.xml.namespace.QName;
import org.apache.axis.Constants;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;

public class GeoPosUtil {
	private static String host = "https://geoposen.item.ntnu.no:8443/geofinder/ws/geofinder/ws";
	
	  //Defines the certificates and passwords required to get access to GeoPos
    //geopos.keystore is a certificate chain containing both client
    //and server certificate.
	
    String keyStore="C:/Program Files/Apache Software Foundation/Tomcat 5.5/webapps/vr/WEB-INF/cert/gposSpinOff.keystore"; //Insert the full path to keystore-file
    String keyStorePassword="spinspin"; //Insert keystore password
    String trustStore="C:/Program Files/Apache Software Foundation/Tomcat 5.5/webapps/vr/WEB-INF/cert/gposSpinOff.keystore";//Insert the full path to keystore-file
    String trustStorePassword="spinspin";//Insert keystore password
    
    public GeoPosUtil() {
        setSecurityProperties();
    }
    
    /**
     * @param String username
     * @param String password
     * @param String targetType
     * @param String targetID
     * @return String[] position
     */
    public String[] getLocation(String username, String password, String targetType, String targetID) {
    
    	String[] ret = new String[2];
        try {
            long t1 = new Date().getTime();
            org.apache.axis.client.Service service = new Service();
            org.apache.axis.client.Call call = (org.apache.axis.client.Call)service.createCall();
            call.setTargetEndpointAddress(new java.net.URL(host));
            call.setOperationName(new QName("http://webservice.gpos.geofinder", "getLocationFor"));

            //The encoding style of a Call return is determined by the encoding style of the Request
   	        call.setEncodingStyle(Constants.NS_URI_XMLSOAP);

            long t2 = new Date().getTime();
            ret[0] = (String) call
                    .invoke(new Object[] { username, password, targetType, targetID });
            long t3 = new Date().getTime();
            System.out.println("Got answer from WS in " + (t3 - t2) + " ms. Total method time is: "
                    + (t3 - t1) + " ms \n ");
            System.out.println(ret[0]);
            System.out.println(ret[1]);
            return ret;

        } catch (Exception e) {
            e.printStackTrace();
            ret[0] = e.toString();
            ret[1] = e.toString();
            System.out.println(ret[0]);
            System.out.println(ret[1]);
            return ret;
        }
    }

   
	private void setSecurityProperties() {

   	 try {
   		 
   		 	System.setProperty("javax.net.ssl.keyStore", keyStore);
            System.setProperty("javax.net.ssl.keyStorePassword",keyStorePassword);
            System.setProperty("javax.net.ssl.trustStore", trustStore);
            System.setProperty("javax.net.ssl.trustStorePassword",trustStorePassword);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
   }
}
