package per.db;
import java.io.Serializable;
import java.lang.Class;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Time;
import java.util.ArrayList;

import per.model.Friend;
import per.model.FriendStatus;
import per.model.Message;
import per.model.User;
import pos.Position;

import java.sql.Timestamp;
import java.text.SimpleDateFormat;

public class DbConnector implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 0L;
	private Connection connection;
	
	
	
	/**
	 *Constructor that makes a connection to the database
	 * 
	 */
	public DbConnector(){
		connection = null; 
		try { 
			String driverName = "org.gjt.mm.mysql.Driver"; // MySQL MM JDBC driver 
			Class.forName(driverName).newInstance();
			
			String serverName = "mysql.stud.ntnu.no"; 
			String mydatabase = "gransath_venn"; 
			String url = "jdbc:mysql://" + serverName + "/" + mydatabase + "?autoReconnect=true"; // a JDBC url 
			String username = "gransath_venn"; 
			String password = "pg_venn"; 
			connection = DriverManager.getConnection(url, username, password);
			System.out.println("connection established");
		} catch (InstantiationException e){
			System.out.println("failed to connect to database " + e);	
		} catch (IllegalAccessException e){
			System.out.println("failed to connect to database " + e);	
		} catch (ClassNotFoundException e) { 
			System.out.println("failed to connect to database " + e);	
		} catch (SQLException e) { 
			System.out.println("failed to connect to database " + e);	
		}
	}
	
	public ArrayList<Friend> getFriendList(User u){
		ArrayList<Friend> fl = new ArrayList<Friend>();
		Statement stm;
		
		try{
			stm = connection.createStatement();
			stm.executeQuery("select * from friend where owner='"+u.getUserId()+"'");
			ResultSet rs = stm.getResultSet();
			ResultSet rs2;
			
			
			while(rs.next()){
				Friend f = new Friend();
				f.setOwner(u);
				User friend = new User();
				int friendId = rs.getInt("friend");
				friend = getUser(friendId, false, true);
				f.setFriend(friend);
				f.setDate(rs.getDate("date"));
				
				Position p = new Position();
				p.setLongitude(0.0);
				p.setLatitude(0.0);
				
				
				String ownStatus = rs.getString("status");
				if (ownStatus.equals("map")){
					f.setOwnStatus(FriendStatus.MAP);
				}
				else if (ownStatus.equals("nearby")){
					f.setOwnStatus(FriendStatus.NEARBY);
				}
				else if (ownStatus.equals("blocked")){
					f.setOwnStatus(FriendStatus.BLOCKED);
					friend.setPosition(p);
				}
				else{
					System.out.println("Friendship does not have status");
				}
				Statement stm2 = connection.createStatement();
				stm2.executeQuery("select status from friend where owner='"+friendId+"' and friend='"+u.getUserId()+"'");
				rs2 = stm2.getResultSet();
				if(rs2.next()){
					String friendsStatus = rs2.getString(1);
					if (friendsStatus.equals("map")){
						f.setFriendsStatus(FriendStatus.MAP);
					}
					else if (friendsStatus.equals("nearby")){
						f.setFriendsStatus(FriendStatus.NEARBY);
					}
					else if (friendsStatus.equals("blocked")){
						f.setFriendsStatus(FriendStatus.BLOCKED);
						friend.setPosition(p);
					}
					else{
						System.out.println("Friendship does not have status");
					}
				}
				else{
					f.setFriendsStatus(FriendStatus.NOT_ACCEPTED);
					
				}
			
				fl.add(f);
				rs2.close();
				stm2.close();
				
				
			}
			rs.close();
			stm.close();
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		return fl;
		
	}
	public ArrayList<Friend> getFriendRequests(User u){
		ArrayList<Friend> fl = new ArrayList<Friend>();
		Statement stm;
		
		try{
			stm = connection.createStatement();
			stm.executeQuery("select * from friend where friend='"+u.getUserId()+"'");
			ResultSet rs = stm.getResultSet();
			
			
			while(rs.next()){
				Friend f = new Friend();
				int ownerId = rs.getInt("owner");
				f.setOwner(getUser(ownerId, false, true));
				
				
			
				f.setFriend(u);
				f.setDate(rs.getDate("date"));
				
					
				
				String friendsStatus = rs.getString("status");
				if (friendsStatus.equals("map")){
					f.setFriendsStatus(FriendStatus.MAP);
				}
				else if (friendsStatus.equals("nearby")){
					f.setFriendsStatus(FriendStatus.NEARBY);
				}
				else if (friendsStatus.equals("blocked")){
					f.setFriendsStatus(FriendStatus.BLOCKED);
				}
				else{
					System.out.println("Friendship does not have status");
				}
				
				fl.add(f);
				
			}
			rs.close();
			stm.close();
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		boolean friend = false;
		
		ArrayList<Friend> flReturn = new ArrayList<Friend>();
		for (Friend f: fl){
			friend = false;
			
			for (Friend f2: u.getFriends()){
				if (((f.getOwner().getUserId()==f2.getFriend().getUserId())&&(f.getFriend().getUserId()==f2.getOwner().getUserId()))){
					
					friend = true;
					
				}
			}
			if(!friend){
				flReturn.add(f);
			}
			
			
		}
		
		return flReturn;
		
	}
	public User getUser(int userId, boolean friend, boolean message){
		
		User u = new User();
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select * from usertable, avatar, device where usertable.id='"+userId+"' and avatar.id=usertable.id" +
					" and device.user=avatar.id and device.status='active'");
			ResultSet rs = stm.getResultSet();
			if(rs.next()){
				u.setUserId(rs.getInt("usertable.id"));
				u.setNickname(rs.getString("nickname"));
				if (message){
					u.setDateOfBirth(rs.getDate("dateofbirth"));
					u.setEmail(rs.getString("email"));
					u.setForename(rs.getString("forename"));
					u.setSurname(rs.getString("surname"));
					u.setGender(rs.getString("gender"));
					
					u.setPersonalMessage(rs.getString("personal_message"));
					u.setPicUrl(rs.getString("pic_url"));
					u.setRelationshipStatus(rs.getString("relationship_status"));
					u.setMacAddress(rs.getString("mac_address"));
					
					u.setPosition(getUserPosition(userId));
					
				}
				if(friend){
					u.setFriends(getFriendList(u));
					
					u.setRecievedMessages(getRecievedMessages(u));
					
					u.setSentMessages(getSentMessages(u));
					
					u.setRecievedFriendRequests(getFriendRequests(u));
					
				}
				
			}
			else{
				return null;
			}
			
			
			rs.close();
			stm.close();
			
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		return u;
		
	}
	public User getUser(String nickname, String password){
		User u = new User();
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select * from usertable where nickname='"+nickname+"' and pass=password('"+password+"')");
			ResultSet rs = stm.getResultSet();
			if (rs.next()){
				u = getUser(rs.getInt("id"), true, true);
				System.out.println("ID: "+u.getUserId() + " " + u.getNickname());
			}
			else{
				return null;
			}
			
			rs.close();
			stm.close();
			
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		return u;
		
	}
	public ArrayList<Message> getSentMessages(User u){
		ArrayList<Message> ml = new ArrayList<Message>();
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select * from message, message_content where sender='"+u.getUserId()+"'" +
					" and message.id=message_content.message order by date desc");
			ResultSet rs = stm.getResultSet();
			
			while(rs.next()){
				Message m = new Message();
				m.setSender(u);
				m.setBody(rs.getString("body"));
				SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yy HH:mm");
				Timestamp ts = rs.getTimestamp("date");
				m.setDate(sdf.format(ts));
				m.setHeader(rs.getString("header"));
				m.setMessageId(rs.getInt("id"));
				m.setType(rs.getString("type"));
				m.setReciever(getUser(rs.getInt("reciever"), false, false));
				
				ml.add(m);
				
			
				
			}
			rs.close();
			stm.close();
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		return ml;
		
	}
	public ArrayList<Message> getRecievedMessages(User u){
		ArrayList<Message> ml = new ArrayList<Message>();
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select * from message, message_content where reciever='"+u.getUserId()+"'" +
					" and message.id=message_content.message order by date desc");
			ResultSet rs = stm.getResultSet();
			
			while(rs.next()){
				Message m = new Message();
				m.setReciever(u);
				m.setBody(rs.getString("body"));
				SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yy HH:mm");
				Timestamp ts = rs.getTimestamp("date");
				m.setDate(sdf.format(ts));
				m.setHeader(rs.getString("header"));
				m.setMessageId(rs.getInt("message.id"));
				m.setType(rs.getString("type"));
				m.setSender(getUser(rs.getInt("sender"), false, false));
				m.setRead(rs.getBoolean("rd"));
				
				ml.add(m);
				
			
			}
			rs.close();
			stm.close();
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		
		
		return ml;
		
	}
	
	public void insertUser(User u){
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeUpdate("insert into device (mac_address, status) values('"+u.getMacAddress()+"', 'active')");
			stm.executeUpdate("insert into usertable (nickname, forename, surname, pass, email, relationship_status) " +
					"values('"+u.getNickname()+"', " +
					"'"+u.getForename()+"', " +
					"'"+u.getSurname()+"', " +
					"password('"+u.getPassword()+"'), " +
					"'"+u.getEmail()+"', " +
					"'"+u.getRelationshipStatus()+"'" +
					")");
			ResultSet rs = stm.executeQuery("select id from usertable where nickname='"+u.getNickname()+"'");
			rs.next();
			int userId = rs.getInt(1);
			
				
			stm.executeUpdate("insert into avatar (id, dateofbirth, gender ) " +
						"values('"+userId+"', " +
						"'"+u.getBirth()+"', " +
						"'"+u.getGender()+"'"+
						")");
			stm.executeUpdate("update device set user='"+userId+"' where mac_address='"+u.getMacAddress()+"'");
				
			
			stm.close();
				
		
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
	}
	
	public void insertFriend(int owner, int friend, String status){
		Statement stm;
		
		try{
			stm = connection.createStatement();
			stm.executeUpdate("insert into friend (owner, friend, status, date) " +
					"values('"+owner+"'," +
					"'"+friend+"'," +
					"'"+status+"'," +
					"now()" +
					")");
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
	}
	
	public void setMessageRead(int messageId){
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeUpdate("update message set rd='1' where id='"+messageId+"'");
		}
		catch (SQLException e){
			e.printStackTrace();
		}
	}
	
	public void insertMessage(Message m){
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeUpdate("lock table message write, message_content write, position read");
			stm.executeUpdate("insert into message (date, type, sender, answer_to, reciever) " +
					"values(now(), " +
					"'"+m.getType()+"', " +
					"'"+m.getSender().getUserId()+"', " +
					"'"+m.getAnswerTo()+"', " +
					"'"+m.getRecieverString()+"'"+
					")");
			stm.executeQuery("select * from message order by date desc limit 1");
			ResultSet rs = stm.getResultSet();
			int messageId = -1;
			if(rs.next()){
				messageId = rs.getInt("id");
			}
			
			
			stm.executeUpdate("insert into message_content (header, body, message) "+
					"values('"+m.getHeader()+"', " +
					"'"+m.getBody()+"',"+
					"'"+messageId+"'"+
					")");
			stm.executeUpdate("unlock tables");
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
	}
	
	public void updateUser(User u){
	
		Statement stm;
		if (u.getBirth() == null){
			if(u.getDateOfBirth() != null){
				u.setBirth(u.getDateOfBirth().toString());
			}
			
		}
		try{
			
			stm = connection.createStatement();
			stm.executeUpdate("update usertable set " +
					"nickname='"+u.getNickname()+"', " +
					"forename='"+u.getForename()+"', " +
					"surname='"+u.getSurname()+"', " +
					"pic_url='"+u.getPicUrl()+"', " +
					"email='"+u.getEmail()+"', " +
					"relationship_status='"+u.getRelationshipStatus()+"', " +
					"personal_message='"+u.getPersonalMessage()+"' " +
					"where id='"+u.getUserId()+"'");
			stm.executeUpdate("update avatar set "+
					"dateofbirth='"+u.getBirth()+"', " +
					"gender='"+u.getGender()+"' " +
					"where id='"+u.getUserId()+"'");
			stm.close();
			System.out.println("etter db");
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
	}
	
	public void updateFriendStatus(int owner, int friend, String status){
		Statement stm;
	
		try{
			stm = connection.createStatement();
			stm.executeUpdate("update friend set " +
					"status='"+status+"'"+
					"where owner='"+owner+"' and " +
					"friend='"+friend+"'");
			stm.close();
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
	}
	public void deleteUser(User u){
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeUpdate("delete from user "+
					"where id='"+u.getUserId()+"'");
			stm.close();
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
	}
	
	public void deleteMessage(Message m){
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeUpdate("update message_content set " +
					"header='Meldingen er slettet'," +
					"body=''" +
					"where message='"+m.getMessageId()+"'");
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
	}
	
	public void setPosition(User u, Position p){
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeUpdate("insert into position (latitude, longitude, user, location_time) " +
					"values('"+p.getLatitude()+"'," +
					"'"+p.getLongitude()+"'," +
					"'"+u.getUserId()+"'," +
					"now()" +
					")");
					
			
				
		
			
				
			
			stm.close();
				
		
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
	}
	
	public Position getUserPosition(int userId){
		Position p = new Position();
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select * from position where user='"+userId+"' order by location_time desc limit 1");
			ResultSet rs = stm.getResultSet();
			if(rs.next()){
				p.setLatitude(rs.getDouble("latitude"));
				p.setLongitude(rs.getDouble("longitude"));
			}
			else{
				p.setLatitude(0.0);
				p.setLongitude(0.0);
			}
			
			
			rs.close();
			stm.close();
			
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		return p;
		
	}
	
	public ArrayList<Friend> getAllFriendsPosition(ArrayList<Friend> fl){
		for(Friend f: fl){
			User friend = f.getFriend();
			friend.setPosition(getUserPosition(friend.getUserId()));
			f.setFriend(friend);			
		}
		return fl;
	}
	
	public boolean posNewerThanHour(int userId){
		
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select (now()-location_time) from position where user='"+userId+"' order by location_time desc limit 1");
			ResultSet rs = stm.getResultSet();
			if (rs.next()){
				return rs.getInt(1)<3500;
			}
			else{
				return false;
			}
			
			
			
		}
		catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		
		
	
	}
public boolean posNewerThanHalfMinute(int userId){
		
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select (now()-location_time) from position where user='"+userId+"' order by location_time desc limit 1");
			ResultSet rs = stm.getResultSet();
			if (rs.next()){
				return rs.getInt(1)<20;
			}
			else{
				return false;
			}
			
			
			
		}
		catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		
		
	
	}
	
	/*
	public void logLocalization(String requester, String requested, Position requesterPos, Position requestedPos) {
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select id from device where mac_address='"+requester+"'");
			ResultSet rs = stm.getResultSet();
			rs.next();
			int requesterDeviceId = rs.getInt("id");
			stm.executeQuery("select id from device where mac_address='"+requested+"'");
			rs = stm.getResultSet();
			rs.next();
			int requestedDeviceId = rs.getInt("id");
			stm.executeUpdate("insert into log_location (requester_device, requested_device, time, requester_long, requester_lat, requested_long, requested_lat) " +
					"values('"+requesterDeviceId+"'," +
					"'"+requestedDeviceId+"'," +
					"now()," +
					"'"+requesterPos.getLongitude()+"'," +
					"'"+requesterPos.getLatitude()+"'," +
					"'"+requestedPos.getLongitude()+"'," +
					"'"+requestedPos.getLatitude()+"'"+
					")");
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}
	}*/	
	
	
	
	
	
	public void closeDb(){
		try {
			this.connection.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		System.out.println("closedDbConnection");
	}

	public ArrayList<User> getAllUsers(int userId) {
		ArrayList<User> ul = new ArrayList<User>();
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select * from usertable, avatar, device where usertable.id <>'"+userId+"' and avatar.id=usertable.id" +
					" and device.user=avatar.id and device.status='active' order by nickname");
			ResultSet rs = stm.getResultSet();
			while(rs.next()){
				User u = new User();
				u.setUserId(rs.getInt("usertable.id"));
				u.setDateOfBirth(rs.getDate("dateofbirth"));
				u.setEmail(rs.getString("email"));
				u.setForename(rs.getString("forename"));
				u.setSurname(rs.getString("surname"));
				u.setGender(rs.getString("gender"));
				u.setNickname(rs.getString("nickname"));
				u.setPersonalMessage(rs.getString("personal_message"));
				u.setPicUrl(rs.getString("pic_url"));
				u.setRelationshipStatus(rs.getString("relationship_status"));
				u.setMacAddress(rs.getString("mac_address"));
				ul.add(u);
				
			}
			
			
			
			rs.close();
			stm.close();
			
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		return ul;
		
	}
	
	public boolean nicknameTaken(String nickname){
		Statement stm;
		boolean taken=false;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select nickname from usertable where nickname='"+nickname+"'");
			ResultSet rs = stm.getResultSet();
			if(rs.next()){
				taken=true;
			}
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
			
		return taken;
	}
	public int updatePassword(String newPass, String oldPass, String nickname){
		Statement stm;
		int yes = 0;
		
		try{
			stm = connection.createStatement();
			yes = stm.executeUpdate("update usertable set " +
					"pass=password('"+newPass+"') " +
					"where nickname='"+nickname+"' "+
					"and pass=password('"+oldPass+"')");
			stm.close();
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
		System.out.println("Yes "+yes);
		return yes;
	}
	public int getUserByMail(String mail){
		int id = 0;
		Statement stm;
		try{
			stm = connection.createStatement();
			stm.executeQuery("select id from usertable where email='"+mail+"' limit 1");
			ResultSet rs = stm.getResultSet();
			if(rs.next()){
				id = rs.getInt(1);
			}
			
			
			rs.close();
			stm.close();
			
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		return id;
		
	}
	public void updatePassword(int id, String pass){
		
		Statement stm;
		
		try{
			
			stm = connection.createStatement();
			stm.executeUpdate("update usertable set " +
					"pass=password('"+pass+"') " +
					"where id='"+id+"'");
			stm.close();
		
			
		}
		catch (SQLException e){
			e.printStackTrace();
		}	
	}
	

	
	
	

}
