package per.location;

import java.io.Serializable;
import java.util.Timer;
import java.util.TimerTask;

import pos.MockPositionParser;
import pos.Position;

import per.db.DbConnector;

import per.model.Device;
import per.model.Friend;
import per.model.FriendLocation;
import per.model.Interval;
import per.model.User;
import pos.PositionParser;

public class Locator implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 0L;
	private PositionParser pp;
	//private MockPositionParser pp;
	private DbConnector dbc;
	private Timer timer = null;
	private TimerTask posTask=null;
	private int counter;
	
	
	private Position position;
	private User u;
	
	public Locator(DbConnector dbc, User u){
		this.dbc = dbc;
		this.u = u;
		pp = new PositionParser();
		//pp = new MockPositionParser();
		
	}
	/*
	public FriendLocation getFriendLocation(String requester, String requested){
		Position requesterPos = pp.getPosition(requester);
		Position requestedPos = pp.getPosition(requested);
		dbc.logLocalization(requester, requested, requesterPos, requestedPos);
		FriendLocation fl = new FriendLocation();
		fl.setRequesterPosition(requesterPos);
		fl.setReqestedPosition(requestedPos);
		return fl;
		return null;
	}
	*/
	public Position getPosition(){
		return position;
	}
	
	public Position getPositionWithoutSave(){
		return pp.getPosition(u.getMacAddress());
	}
	
	public Position getOwnPosition(){
		Position pos = pp.getPosition(u.getMacAddress());
		u.setPosition(pos);
		dbc.setPosition(u, pos);
		return pos;
		
	}
	public Position getOwnPositionStartThread(){
		System.out.println("Get own position start thread called");
		Position pos = pp.getPosition(u.getMacAddress());
		u.setPosition(pos);
		dbc.setPosition(u, pos);
		LocationThread lt = 	new LocationThread();
		lt.start();
		return pos;
		
	}

	
	public class LocationThread extends Thread{
		
		private int interval;
		private boolean running;
		
		public LocationThread(){
			
			interval = Interval.THIRTY_SECONDS.millisec();
			running = true;
		
			
		}
		public void run(){
			System.out.println("Inne i run "+interval);
			while(running){
				try {
					Thread.sleep(interval);
					dbc.setPosition(u, getOwnPositionInsideRun());
					System.out.println("Position saved");
				} catch (InterruptedException e) {
					System.out.println("Interrupted exception");
					e.printStackTrace();
				}
			}
		}
		public Position getOwnPositionInsideRun(){
			
			Position oldPosition = u.getPosition();
			Position pos = pp.getPosition(u.getMacAddress());
			u.setPosition(pos);
		
			if(oldPosition==null){
				interval = Interval.THIRTY_SECONDS.millisec();
			}
			else if ((pos.getLatitude()==0.0)&&(pos.getLongitude()==0.0)){
				if(dbc.posNewerThanHour(u.getUserId())&&(interval == Interval.ONE_HOUR.millisec())){
					 running = false;
					System.out.println("Runner stopped because of newer location, hour");
				}
				interval = Interval.ONE_HOUR.millisec();
			}
			else if((System.currentTimeMillis()-pos.getLastUpdate().getTime())> 420000){
				System.out.println("Last update was: "+(System.currentTimeMillis()-pos.getLastUpdate().getTime())+" One hour because of update");
				pos.setLatitude(0.0);
				pos.setLongitude(0.0);
				
			}
			else if(hasUserMoved(oldPosition, pos)){
				if(dbc.posNewerThanHalfMinute(u.getUserId())&&(interval == Interval.THIRTY_SECONDS.millisec())){
					 running = false;
					System.out.println("Runner stopped because of newer location, thirty seconds");
				}
				interval = Interval.THIRTY_SECONDS.millisec();
			}
			else if (!hasUserMoved(oldPosition, pos)){
				interval=Interval.TWO_AND_A_HALF_MINUTE.millisec();
			}
			else{
				System.out.println("Feil i get own pos");
			}
			System.out.println("Hentet posisjon: "+pos.getLatitude() + ", "+pos.getLongitude()+". Intervallet er: "+interval);
		
			return pos;
			
			
			
		}
		private boolean hasUserMoved(Position oldPos, Position newPos){
			double latDist = Math.abs(oldPos.getLatitude()-newPos.getLatitude());
			double longDist = Math.abs(oldPos.getLongitude()-newPos.getLongitude());
			System.out.println("Lat dist: "+latDist+" Long dist: "+longDist);
			return (longDist>0.0001)||(latDist>0.0001);
		}
	}
	
	
	
}
