package per.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;

import pos.Position;


public class User implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 0L;
	private int userId;
	private String nickname;
	private String forename;
	private String surname;
	private Date dateOfBirth;
	private String birth;
	private String gender;
	private String password;
	private String picUrl;
	private String email;
	private String relationshipStatus;
	private ArrayList<Friend> friends;
	private ArrayList<Message> sentMessages;
	private ArrayList<Message> recievedMessages;
	private String macAddress;
	private String personalMessage;
	private Position position;
	private ArrayList<Friend> recievedFriendRequests;
	
	private String userIdString;
	
	public String getUserIdString() {
		return userIdString;
	}
	public void setUserIdString(String userIdString) {
		this.userIdString = userIdString;
	}
	
	public int getUserId() {
		return userId;
	}
	public void setUserId(int userId) {
		this.userId = userId;
		this.userIdString=Integer.toString(userId);
	}
	public String getNickname() {
		return nickname;
	}
	public void setNickname(String nickname) {
		this.nickname = nickname;
	}
	public String getForename() {
		return forename;
	}
	public void setForename(String forename) {
		this.forename = forename;
	}
	public String getSurname() {
		return surname;
	}
	public void setSurname(String surname) {
		this.surname = surname;
	}
	public Date getDateOfBirth() {
		return dateOfBirth;
	}
	public void setDateOfBirth(Date dateOfBirth) {
		this.dateOfBirth = dateOfBirth;
	}
	public String getGender() {
		return gender;
	}
	public void setGender(String gender) {
		this.gender = gender;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public String getPicUrl() {
		return picUrl;
	}
	public void setPicUrl(String picUrl) {
		this.picUrl = picUrl;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getRelationshipStatus() {
		return relationshipStatus;
	}
	public void setRelationshipStatus(String relationshipStatus) {
		this.relationshipStatus = relationshipStatus;
	}
	public ArrayList<Friend> getFriends() {
		return friends;
	}
	public void setFriends(ArrayList<Friend> friends) {
		this.friends = friends;
	}
	public String getMacAddress() {
		return macAddress;
	}
	public void setMacAddress(String macAddress) {
		this.macAddress = macAddress;
	}
	public String getPersonalMessage() {
		return personalMessage;
	}
	public void setPersonalMessage(String personalMessage) {
		this.personalMessage = personalMessage;
	}
	public ArrayList<Message> getSentMessages() {
		return sentMessages;
	}
	public void setSentMessages(ArrayList<Message> sentMessages) {
		this.sentMessages = sentMessages;
	}
	public ArrayList<Message> getRecievedMessages() {
		return recievedMessages;
	}
	public void setRecievedMessages(ArrayList<Message> recievedMessages) {
		this.recievedMessages = recievedMessages;
	}
	public void addFriend(Friend f){
		friends.add(f);
	}
	public void removeFriend(Friend f){
		friends.remove(f);
	}
	public void addRecievedMessage(Message m){
		recievedMessages.add(m);
	}
	public void removeRecievedMessage(Message m){
		recievedMessages.remove(m);
	}
	public ArrayList<Message> getUnreadMessages(){
		ArrayList<Message> ml = new ArrayList<Message>();
		for (Message m: recievedMessages){
			if (!m.isRead()){
				ml.add(m);
			}
		}
		
		return ml;
	}
	public void addSentMessage(Message m){
		sentMessages.add(m);
	}
	public void removeSentMessage(Message m){
		sentMessages.remove(m);
	}
	public Position getPosition() {
		return position;
	}
	public void setPosition(Position position) {
		this.position = position;
	}
	public ArrayList<Friend> getRecievedFriendRequests() {
		return recievedFriendRequests;
	}
	public void setRecievedFriendRequests(ArrayList<Friend> recievedFriendRequests) {
		this.recievedFriendRequests = recievedFriendRequests;
	}
	public String getBirth() {
		return birth;
	}
	public void setBirth(String birth) {
		this.birth = birth;
	}
	
	
	
	
}
