package pos;

import geoPos.GeoPosUtil;

import java.io.File;
import java.io.StringReader;
import java.util.Date;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;



public class PositionParser {
	
	public Position getPosition(String macAddress){
		Position pos = new Position();
	
		GeoPosUtil gpu = new GeoPosUtil();
		String[] response = 
			gpu.getLocation("gransath:TT", "geo791", "MAC", macAddress);
	
	     for (int i = 0; i<response.length; i++){
	    	 if (response[i]!=null){
	    		 pos.setLatitude(getLat(response[i]));
	    		 pos.setLongitude(getLong(response[i]));
	    		 pos.setLastUpdate(getLastUpdate(response[i]));
	    	 }
	     }
	          
	          return pos;
		}
	
	private double getLong(String res){
		double d = 0.0;

		try {
			//File file = new File("xml/svar.xml");
			DocumentBuilderFactory factory =
			DocumentBuilderFactory.newInstance();
			DocumentBuilder db = factory.newDocumentBuilder();
			//Document doc = db.parse(file);
			InputSource inStream = new InputSource();
			inStream.setCharacterStream(new StringReader(res));
			Document doc = db.parse(inStream);
			doc.getDocumentElement().normalize();
			NodeList nodeLst = doc.getElementsByTagName("geoLongitude");
			Node fstNode = nodeLst.item(0);
			Element fstElmnt = (Element) fstNode;
			NodeList fstNm = fstElmnt.getChildNodes();
			String s = ((Node) fstNm.item(0)).getNodeValue();
			 try {
		         d = Double.valueOf(s.trim()).doubleValue();
		      } catch (NumberFormatException nfe) {
		         System.out.println("NumberFormatException: " + nfe.getMessage());
		      }
			} catch (Exception e) {
				System.out.println(e);
			}
				
			return d;
	}
	private double getLat(String res){
		double d = 0.0;

		try {
			//File file = new File("xml/svar.xml");
			DocumentBuilderFactory factory =
			DocumentBuilderFactory.newInstance();
			DocumentBuilder db = factory.newDocumentBuilder();
			//Document doc = db.parse(file);
			InputSource inStream = new InputSource();
			inStream.setCharacterStream(new StringReader(res));
			Document doc = db.parse(inStream);
			doc.getDocumentElement().normalize();
			NodeList nodeLst = doc.getElementsByTagName("geoLatitude");
			Node fstNode = nodeLst.item(0);
			Element fstElmnt = (Element) fstNode;
			NodeList fstNm = fstElmnt.getChildNodes();
			String s = ((Node) fstNm.item(0)).getNodeValue();
			 try {
		         d = Double.valueOf(s.trim()).doubleValue();
		      } catch (NumberFormatException nfe) {
		         System.out.println("NumberFormatException: " + nfe.getMessage());
		      }
			} catch (Exception e) {
				System.out.println(e);
			}
				
			return d;
	}
	private Date getLastUpdate(String res){
		Date t = new Date(0);

		try {
			//File file = new File("xml/svar.xml");
			DocumentBuilderFactory factory =
			DocumentBuilderFactory.newInstance();
			DocumentBuilder db = factory.newDocumentBuilder();
			//Document doc = db.parse(file);
			InputSource inStream = new InputSource();
			inStream.setCharacterStream(new StringReader(res));
			Document doc = db.parse(inStream);
			doc.getDocumentElement().normalize();
			NodeList nodeLst = doc.getElementsByTagName("changedOn");
			Node fstNode = nodeLst.item(0);
			Element fstElmnt = (Element) fstNode;
			NodeList fstNm = fstElmnt.getChildNodes();
			String s = ((Node) fstNm.item(0)).getNodeValue();
			 try {
		         t.setTime(Long.valueOf(s.trim()).longValue());
		      } catch (NumberFormatException nfe) {
		         System.out.println("NumberFormatException: " + nfe.getMessage());
		      }
			} catch (Exception e) {
				System.out.println(e);
			}
				
			return t;
	}


}
